unit MainU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    panBottom: TPanel;
    btOpenLog: TButton;
    odOpenLog: TOpenDialog;
    sdSaveRLE: TSaveDialog;
    btSaveRLE: TButton;
    btClose: TButton;
    Image1: TImage;
    lbCellsCount: TLabel;
    lbONCount: TLabel;
    lbBoundsRect: TLabel;
    procedure btOpenLogClick(Sender: TObject);
    procedure Memo1Click(Sender: TObject);
    procedure btSaveRLEClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Memo1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    procedure LogDissection(S: String);
    procedure ImageChange;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

const
  CellX = 8;
  XV: array [0..195] of Integer =
    ( 0, -1, -1, -1,  0,  0,  1,  1,  1,  2,  2,  2,  0,  1,
      2, -1, -2, -2, -2, -2, -2, -1,  0,  1,  2,  3,  3,  3,
      3,  3,  1,  2,  3,  0, -1, -2, -3, -3, -3, -3, -3, -3,
     -3, -2, -1,  0,  1,  2,  3,  4,  4,  4,  4,  4,  4,  4,
      2,  3,  4,  1,  0, -1, -2, -3, -4, -4, -4, -4, -4, -4,
     -4, -4, -4, -3, -2, -1,  0,  1,  2,  3,  4,  5,  5,  5,
      5,  5,  5,  5,  5,  5,  3,  4,  5,  2,  1,  0, -1, -2,
     -3, -4, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -5, -4,
     -3, -2, -1,  0,  1,  2,  3,  4,  5,  6,  6,  6,  6,  6,
      6,  6,  6,  6,  6,  6,  4,  5,  6,  3,  2,  1,  0, -1,
     -2, -3, -4, -5, -6, -6, -6, -6, -6, -6, -6, -6, -6, -6,
     -6, -6, -6, -5, -4, -3, -2, -1,  0,  1,  2,  3,  4,  5,
      6,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,
      5,  6,  7,  4,  3,  2,  1,  0, -1, -2, -3, -4, -5, -6);
  YV: array [0..195] of Integer =
    ( 0, -1,  0,  1, -1,  1, -1,  0,  1, -1,  0,  1, -2, -2,
     -2, -2, -2, -1,  0,  1,  2,  2,  2,  2,  2,  0,  1,  2,
     -1, -2, -3, -3, -3, -3, -3, -3, -3, -2, -1,  0,  1,  2,
      3,  3,  3,  3,  3,  3,  3,  1,  2,  3,  0, -1, -2, -3,
     -4, -4, -4, -4, -4, -4, -4, -4, -4, -3, -2, -1,  0,  1,
      2,  3,  4,  4,  4,  4,  4,  4,  4,  4,  4,  2,  3,  4,
      1,  0, -1, -2, -3, -4, -5, -5, -5, -5, -5, -5, -5, -5,
     -5, -5, -5, -4, -3, -2, -1,  0,  1,  2,  3,  4,  5,  5,
      5,  5,  5,  5,  5,  5,  5,  5,  5,  3,  4,  5,  2,  1,
      0, -1, -2, -3, -4, -5, -6, -6, -6, -6, -6, -6, -6, -6,
     -6, -6, -6, -6, -6, -5, -4, -3, -2, -1,  0,  1,  2,  3,
      4,  5,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,
      6,  4,  5,  6,  3,  2,  1,  0, -1, -2, -3, -4, -5, -6,
     -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7, -7);

var
  SplittedStr: TStringList;
  FC: array [0..13, 0..13] of Boolean;
  X, Y, CellsCount, ONCount: Integer;
  GoEBMP: TBitmap;

{$R *.DFM}

procedure TForm1.btOpenLogClick(Sender: TObject);
begin
  if odOpenLog.Execute then
  begin
    Memo1.Lines.Clear;
    Memo1.Lines.LoadFromFile(odOpenLog.FileName);
    Memo1Click(Self);
  end;
end;

procedure TForm1.Memo1Click(Sender: TObject);
var
  S: String;
begin
  S := Memo1.Lines[SendMessage(Memo1.Handle, EM_LINEFROMCHAR, Memo1.SelStart, 0)];
  LogDissection(S);
  ImageChange;
end;

procedure TForm1.LogDissection(S: String);
var
  I, J, XC, YC, H: Integer;
begin
  SplittedStr.Clear;
  for I := 0 to 13 do
  for J := 0 to 13 do
    FC[I, J] := False;
  CellsCount := 0;
  OnCount := 0;
  if S <> '' then
  begin
    for I := 0 to 6 do
    begin
      TrimLeft(S);
      SplittedStr.Add(Copy(S, 1, Pos(' ', S)-1));
      Delete(S, 1, Pos(' ', S));
    end;

    CellsCount := StrToInt(SplittedStr[5]);
    X := 1;
    Y := 1;
    while X*Y < CellsCount do
      if X = Y then X := X + 1 else Y := Y + 1;
    XC := (X + 1) div 2 - 1;
    YC := Y div 2;

    for I := 1 to Length(S) do
    begin
      H := ord(S[I]);
      if H > 64 then H := H - 7;
      H := H and $0000000F;
      for J := 0 to 3 do
      begin
        if (H and $00000001) <> 0 then
        begin
          FC[XC + XV[4*(I-1) + J], YC + YV[4*(I-1) + J]] := True;
          Inc(ONCount);
        end;
        H := H shr 1;
      end;
      if 4*I >= CellsCount then break;
    end;
  end;
end;

procedure TForm1.ImageChange;
var
  I, J: Integer;
begin
  GoEBMP.Canvas.Brush.Color := clWhite;
  GoEBMP.Canvas.FillRect(GoEBMP.Canvas.ClipRect);
  GoEBMP.Canvas.Brush.Color := clGreen;
  for J := 0 to Y-1 do
  for I := 0 to X-1 do
    if FC[I, J] then
      GoEBMP.Canvas.FillRect(Rect(I*CellX, J*CellX, (I+1)*CellX, (J+1)*CellX));
  Image1.Picture.Bitmap.Assign(GoeBMP);
  if CellsCount <> 0
  then
  begin
    lbBoundsRect.Caption := IntToStr(X) + 'x' + IntToStr(Y);
    lbCellsCount.Caption := 'Cells count: ' + IntToStr(CellsCount);
    lbONCount.Caption := 'ON count: ' + IntToStr(ONCount);
  end
  else
  begin
    lbBoundsRect.Caption := '';
    lbCellsCount.Caption := '';
    lbONCount.Caption := '';
  end;
end;

procedure TForm1.btSaveRLEClick(Sender: TObject);
var
  SL: TStringList;
  I, J: Integer;
  SCurrent: String;
begin
  if sdSaveRLE.Execute then
  begin
    SL := TStringList.Create;
    if SplittedStr[6] = '0' then SCurrent := '' else SCurrent := 'Uncomplete ';
    SL.Add('#C ' + SCurrent + 'Garden of Eden. Found '
      + SplittedStr[0] + ' ' + SplittedStr[1] + '.');
    if Pos('A', SplittedStr[2]) > 0 then SCurrent := ' Auto correction' else SCurrent := '';
    if Pos('R', SplittedStr[2]) > 0
    then
      if SCurrent <> ''
      then SCurrent := SCurrent + ' + Random threshold'
      else SCurrent := SCurrent + ' Random threshold'
    else SCurrent := SCurrent + '';
    if SCurrent = '' then SCurrent := 'None';
    SL.Add('#C Checked modes:' + SCurrent);
    if Pos('R', SplittedStr[2]) > 0
      then SCurrent := SplittedStr[3] + ' - ' else SCurrent := '';
    SL.Add('#C White odds: ' + SCurrent + SplittedStr[4]);
    SL.Add('#C Amount of substantial cells: ' + SplittedStr[5]);
    SL.Add('#C Amount of ON cells: ' + IntToStr(ONCount));
    SL.Add('#r B3/S23');
    SL.Add('#P 0 0');
    for J := 0 to Y-1 do
    begin
      SCurrent := '';
      for I := 0 to X-1 do
        if FC[I, J]
        then SCurrent := SCurrent + 'o'
        else SCurrent := SCurrent + '.';
      SL.Add(SCurrent);
    end;
    SL.SaveToFile(sdSaveRLE.FileName);
    SL.Free;
  end;
end;

procedure TForm1.btCloseClick(Sender: TObject);
begin
 Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SplittedStr := TStringList.Create;
  GoEBMP := TBitmap.Create;
  GoEBMP.Width := CellX * 14 + 2;
  GoEBMP.Height := CellX * 14 + 2;
  lbBoundsRect.Caption := '';
  lbCellsCount.Caption := '';
  lbONCount.Caption := '';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  SplittedStr.Free;
  GoEBMP.Free;
end;

procedure TForm1.Memo1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_DOWN) or (Key = VK_UP) then Memo1Click(Sender);
end;

end.
